/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.portlets.home.renderer.html;

import ic3.portlets.home.component.UIHomePortlet;
import java.io.IOException;
import java.util.ResourceBundle;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: HomePortletRenderer.java,v 1.1 2004/10/27 03:04:10 tuan08 Exp $ 
 */
public class HomePortletRenderer extends HtmlBasicRenderer {

  public void encodeChildren(FacesContext context, UIComponent component)  throws IOException {
    UIHomePortlet uiHome = (UIHomePortlet) component;
    ResponseWriter w = context.getResponseWriter();
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    w.write("<table class='UIHomePortlet'>") ;
    w.  write("<tr>") ;
    w.    write("<th colspan='2'>") ; 
    w.      write(res.getString("UIHomePortlet.header.welcome-user")) ;
    w.    write("</th>") ;
    w.  write("</tr>") ;
    w.  write("<tr>") ;
    
    w.    write("<td>") ; 
    w.      write("<div class='h2'>") ; 
    w.        write(res.getString("UIHomePortlet.header.welcome-communication-center")) ;
    w.      write("</div>") ; 
    w.    write("</td>") ;
    
    w.    write("<td>") ;
    w.      write("<div class='h2'>") ; 
    w.        write(res.getString("UIHomePortlet.header.what-next")) ;
    w.      write("</div>") ; 
    w.    write("</td>") ;
    w.  write("</tr>") ;
    
    w.  write("<tr>") ;
    w.    write("<td class='info'>") ; 
    w.        write(res.getString("UIHomePortlet.text.introduction-1")) ; 
    w.        write(res.getString("UIHomePortlet.text.introduction-2")) ; 
    w.    write("</td>") ;
    
    w.    write("<td>") ; 
    renderNew(w, uiHome, res) ;
    w.    write("</td>") ;
    w.  write("</tr>") ;
    w.write("</table>") ;
  }
  
  public void renderNew(ResponseWriter w, UIHomePortlet uiHome, 
                        ResourceBundle res) throws IOException {
    Object[] params = { new Integer(uiHome.getNewLabResults()) } ;
    String label = ft_.format(res.getString("UIHomePortlet.label.lab-result-new"), params) ;
    w.write("<table class='new-block'>") ;
    w.  write("<tr>") ;
    w.    write("<td class='icon'>") ; 
    w.      write(res.getString("UIHomePortlet.img.lab-result")) ;
    w.    write("</td>") ; 
    w.    write("<td>") ; 
    linkRenderer_.render(w, uiHome , label, UIHomePortlet.SHOW_LAB_RESUTL) ;
    w.    write("</td>") ;
    w.  write("</tr>") ;
    
    w.  write("<tr>") ;  
    w.    write("<td class='icon'>") ; 
    w.      write(res.getString("UIHomePortlet.img.message")) ;
    w.    write("</td>") ; 
    w.    write("<td>") ; 
    
    params[0] =  new Integer(uiHome.getNewMessages())  ;
    label = ft_.format(res.getString("UIHomePortlet.label.message-new"), params) ;
    linkRenderer_.render(w, uiHome , label, UIHomePortlet.SHOW_MESSAGE_CENTER) ;
    w.    write("</td>") ;
    w.  write("</tr>") ;
    
    w.  write("<tr>") ; 
    w.    write("<td class='icon'>") ; 
    w.      write(res.getString("UIHomePortlet.img.symptoms")) ;
    w.    write("</td>") ;
    w.    write("<td>") ; 
    linkRenderer_.render(w, uiHome , res.getString("UIHomePortlet.label.symptoms-new"), 
                         UIHomePortlet.SHOW_SYMPTOMS) ;
    w.    write("</td>") ; 
    w.  write("</tr>") ;
    w.write("</table>") ; 
  }
}
