/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.sample.component;

import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.Cell;
import org.exoplatform.faces.core.component.model.ComponentCell;
import org.exoplatform.faces.core.component.model.FormButton;
import org.exoplatform.faces.core.component.model.HeaderRow;
import org.exoplatform.faces.core.component.model.LabelCell;
import org.exoplatform.faces.core.component.model.ListComponentCell;
import org.exoplatform.faces.core.component.model.Row;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyStringValidator;
import ic3.sample.*;
import ic3.sample.model.* ;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIPatientForm.java,v 1.1 2004/09/30 18:06:02 tuan08 Exp $
 */
public class UIPatientForm extends UISimpleForm {
  private UIStringInput firstNameInput_ ;
  private UIStringInput lastNameInput_ ;
  private UIStringInput emailInput_ ;
  private MyService service_ ;
  private Patient patient_ ;
  
  public UIPatientForm(MyService service, ResourceBundle res) throws Exception {
    super("groupForm", "post", null) ;
    setClazz("UIGroupForm") ;
    setId("UIGroupForm");
    service_ = service ;
    firstNameInput_ = new UIStringInput("firstName", "")
		.addValidator(EmptyStringValidator.class);
    lastNameInput_ = new UIStringInput("lastName", "") ;
    emailInput_ = new UIStringInput("email", "") ;
    add(new HeaderRow().
        add(new Cell(res.getString("header.add-edit-patient")).
            addColspan("2")));
    add(new Row().
        add(new LabelCell(res.getString("label.first-name"))).
        add(new ComponentCell(this, firstNameInput_)));
    add(new Row().
        add(new LabelCell(res.getString("label.last-name"))).
        add(new ComponentCell(this, lastNameInput_)));
    add(new Row().
        add(new LabelCell(res.getString("label.email"))).
        add(new ComponentCell(this, emailInput_)));
    add(new Row().
        add(new ListComponentCell().
            add(new FormButton(res.getString("button.save"), SAVE_ACTION)).
            add(new FormButton(res.getString("button.cancel"), CANCEL_ACTION)).
            addColspan("2").addAlign("center"))) ;
    
    addValidator(MyFormValidator.class);
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public void setPatient(Patient patient) throws Exception {
    patient_  = patient ;
    if(patient == null) {
      firstNameInput_.setValue("") ;
      lastNameInput_.setValue("") ;
      emailInput_.setValue("") ;
    } else {
      firstNameInput_.setValue(patient.getFirstName()) ;
      lastNameInput_.setValue(patient.getLastName()) ;
      emailInput_.setValue(patient.getEMail()) ;
    }
  }

  static public class MyFormValidator implements Validator {
    public void validate(FacesContext context, UIComponent component,
                         Object value) throws ValidatorException {
      UIPatientForm uiForm = (UIPatientForm) component;
      //throw new ValidatorException(new FacesMessage());
      System.out.println("call my form validator") ;
    }
  }

  static public class CancelActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIPatientForm uiForm = (UIPatientForm) event.getComponent() ;
  		uiForm.setRenderedSibling(UIListPatient.class);
    }
  }
  
  static public class SaveActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIPatientForm uiForm = (UIPatientForm) event.getComponent() ;
      Patient patient = uiForm.patient_ ;
  		if(patient == null) {
  		  patient = Patient.createPatient(event.hashCode()) ;
  		  uiForm.service_.getPatients().add(patient) ;
  		}
  		patient.setFirstName(uiForm.firstNameInput_.getValue());
  		patient.setLastName(uiForm.lastNameInput_.getValue()) ;
  		patient.setEMail(uiForm.emailInput_.getValue()) ;
  		UIListPatient uiPatientList = 
			  (UIListPatient)uiForm.getSibling(UIListPatient.class) ;
  		uiPatientList.update() ;
  		uiForm.setRenderedSibling(UIListPatient.class);
    }
  }
}
