/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.sample.renderer.html;

import java.util.List;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter ;
import java.io.IOException;

import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import ic3.sample.component.*;

public class TestResultRenderer extends HtmlBasicRenderer {
 
  public void encodeBegin(FacesContext context, UIComponent component ) throws IOException {
    UITestResult uiTestResult = (UITestResult) component;
    ResponseWriter w = context.getResponseWriter() ;
    w.write("This is a test\n");
    w.write(uiTestResult.getSayHello()) ;
  }
  
  public void encodeChildren(FacesContext context, UIComponent component ) throws IOException {
    UITestResult uiTestResult = (UITestResult) component;
    ResponseWriter w = context.getResponseWriter() ;
    w.write("<div class='UITestResult'>");
    List children = uiTestResult.getChildren() ;
    for(int i=0; i < children.size(); i++) {
      UIComponent uiChild = (UIComponent) children.get(i);
      if(uiChild.isRendered()) {
        uiChild.encodeBegin(context) ;
        uiChild.encodeChildren(context) ;
        uiChild.encodeEnd(context) ;
      }
    }
    w.write("</div>");
  }
}
