/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package ic3.sample.test;

import java.util.ResourceBundle;
import org.exoplatform.portal.test.JSFComponentTestCase;
import org.exoplatform.portal.test.TestPortletFacesServlet;
import org.exoplatform.test.mocks.portlet.*;
import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.validator.*;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: TestTestResultPortlet.java,v 1.1 2004/09/30 18:06:02 tuan08 Exp $
 */
public class TestTestResultPortlet extends JSFComponentTestCase {
  
  public TestTestResultPortlet( String name ) {
    super( name );
  }
  
  
  public void setUp() throws Exception {
    super.setUp() ;
    MockPortletFacesContext context = 
        MockPortletFacesContext.getMockPortletFacesContextCurrentInstance() ;
    MockPortletPreferences prefs = (MockPortletPreferences) context.getPortletPreferences();
    prefs.setValue("value","value") ;
    ResourceBundle res = 
      ResourceBundle.getBundle("locale.portlet.TestResult.TestResultPortlet") ;
    MockPortletConfig config = context.getMockPortletConfig() ;
    config.setResourceBundle(res) ;
  }
  
  public void testResult() throws Exception {
    ExoWebClient webClient = new ExoWebClient("exo", "");
    TestSuites suites = new TestSuites() ;
    suites.addSuite(new TestResultPortletSuite()) ;
    webClient.run(suites) ;
    if(webClient.hasError()) fail("There is an unit test fail") ;
  }
  
  static public class  TestResultPortletSuite extends WebUnitSuite {
    public TestResultPortletSuite() {
      super("TestResultPortletSuite", "Go to the test result portlet page and do some test") ;
      addWebUnit(new NewMockSessionUnit("NewSession", "Create new mock session for message center portlet").
                 setServletName(TestPortletFacesServlet.class.getName()).
                 setUIComponent("ic3.sample.component.UITestResult").
                 addValidator(new ExpectTextValidator("e")).
                 addValidator(new ExpectTextValidator("Hello World")));
      
      addWebUnit(new ClickURLLinkUnit("ClickViewPatient", "View first patient in the list").
                 setURL("uicomponent=UIListPatient&op=view&objectId=0").
                 addValidator(new ExpectTextValidator("First Name:"))) ;
      
      addWebUnit(new ClickLink("GoBackToListPatient", "Click Back button to go back to list patient").
                 setTextLink("Back").
                 addValidator(new ExpectLinkWithURLValidator("uicomponent=UIListPatient&op=view&objectId=0"))) ;

      addWebUnit(new ClickURLLinkUnit("ClickAddAccount", "Add").
		       setURL("op=add")) ;

      addWebUnit(new ClickLinkWithText("ClickCancelLink", "Go back to the patient list screen").
            setTextLink("cancel")) ;
    }
  }
}
